(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('@k-adam/ngx-loading-spinner', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global['k-adam'] = global['k-adam'] || {}, global['k-adam']['ngx-loading-spinner'] = {}), global.ng.core, global.rxjs, global.rxjs.operators, global.ng.platformBrowser));
}(this, (function (exports, i0, rxjs, operators, platformBrowser) { 'use strict';

    var SpinnerActionType;
    (function (SpinnerActionType) {
        SpinnerActionType[SpinnerActionType["Show"] = 0] = "Show";
        SpinnerActionType[SpinnerActionType["Hide"] = 1] = "Hide";
        SpinnerActionType[SpinnerActionType["None"] = 2] = "None";
    })(SpinnerActionType || (SpinnerActionType = {}));
    ;
    var SpinnerAction = /** @class */ (function () {
        function SpinnerAction() {
        }
        return SpinnerAction;
    }());
    var NgxLoadingSpinnerService = /** @class */ (function () {
        function NgxLoadingSpinnerService() {
            this.visibleSubject = new rxjs.BehaviorSubject(false);
            this.delayedSubject = new rxjs.Subject();
            this.immediateSubject = new rxjs.Subject();
            this.actionRequested = SpinnerActionType.None;
            this.actionExecuted = SpinnerActionType.None;
            this._timeout = 10000;
            this._threshold = 500;
            this.raceSubject();
        }
        Object.defineProperty(NgxLoadingSpinnerService.prototype, "timeout", {
            set: function (timeout) {
                this._timeout = timeout;
                this.patchShow();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgxLoadingSpinnerService.prototype, "threshold", {
            set: function (threshold) {
                this._threshold = threshold;
                this.patchShow();
            },
            enumerable: false,
            configurable: true
        });
        NgxLoadingSpinnerService.prototype.raceSubject = function () {
            var _this = this;
            var delayedSubject = this.delayedSubject.pipe(operators.map(function (t) { return ({ type: t, immediate: false }); }));
            var immediateSubject = this.immediateSubject.pipe(operators.map(function (t) { return ({ type: t, immediate: true }); }));
            var thresholdObserver = rxjs.race(delayedSubject.pipe(operators.debounce(function () { return rxjs.timer(_this._threshold); })), immediateSubject).pipe(operators.take(1), operators.tap(function (action) {
                _this.updatePublicState(action.type);
            }), operators.map(function (action) {
                if (action.type == SpinnerActionType.Show) {
                    return { type: SpinnerActionType.Hide, immediate: false };
                }
                else {
                    return action;
                }
            }));
            var timeoutObserver = rxjs.race(thresholdObserver.pipe(operators.switchMap(function (action) { return (action.immediate ? rxjs.of(action) : rxjs.timer(_this._timeout).pipe(operators.map(function (_) { return action; }))); })), immediateSubject).pipe(operators.take(1));
            timeoutObserver.subscribe(function (action) {
                _this.updatePublicState(action.type);
            }, function (error) { return console.error(error); }, function () { return _this.raceSubject(); });
        };
        NgxLoadingSpinnerService.prototype.show = function () {
            this.actionRequested = SpinnerActionType.Show;
            this.immediateSubject.next(SpinnerActionType.None);
            this.delayedSubject.next(SpinnerActionType.Show);
        };
        NgxLoadingSpinnerService.prototype.hide = function () {
            this.actionRequested = SpinnerActionType.Hide;
            this.immediateSubject.next(SpinnerActionType.Hide);
        };
        //
        NgxLoadingSpinnerService.prototype.patchShow = function () {
            if (this.actionRequested == SpinnerActionType.Show) {
                if (this.actionExecuted == SpinnerActionType.Show) {
                }
                else {
                    this.immediateSubject.next(SpinnerActionType.None);
                    this.delayedSubject.next(SpinnerActionType.Show);
                }
            }
        };
        NgxLoadingSpinnerService.prototype.updatePublicState = function (type) {
            switch (type) {
                case SpinnerActionType.Show:
                    this.actionExecuted = type;
                    this.visibleSubject.next(true);
                    break;
                case SpinnerActionType.Hide:
                    this.actionExecuted = type;
                    this.visibleSubject.next(false);
                    break;
            }
        };
        return NgxLoadingSpinnerService;
    }());
    NgxLoadingSpinnerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxLoadingSpinnerService_Factory() { return new NgxLoadingSpinnerService(); }, token: NgxLoadingSpinnerService, providedIn: "root" });
    NgxLoadingSpinnerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxLoadingSpinnerService.ctorParameters = function () { return []; };

    var NgxLoadingSpinnerComponent = /** @class */ (function () {
        function NgxLoadingSpinnerComponent(service) {
            this.service = service;
            this.zIndex = 100;
            this.visible = false;
        }
        Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "timeout", {
            set: function (v) {
                this.service.timeout = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "threshold", {
            set: function (v) {
                this.service.threshold = v;
            },
            enumerable: false,
            configurable: true
        });
        NgxLoadingSpinnerComponent.prototype.ngOnInit = function () {
            this.subscribeToService();
        };
        NgxLoadingSpinnerComponent.prototype.subscribeToService = function () {
            var _this = this;
            this.service.visibleSubject.subscribe(function (spinnerVisible) {
                _this.visible = spinnerVisible;
            });
        };
        return NgxLoadingSpinnerComponent;
    }());
    NgxLoadingSpinnerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-loading-spinner',
                    template: "<div class=\"overlay noselect\" [class.on]=\"visible\" [class.off]=\"!visible\" [style.zIndex]=\"zIndex\">\r\n    <div class=\"spinner-container\" *ngIf=\"!template; else showTemplate\">\r\n        <div class=\"spinner-item lds-default\"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>\r\n        <div class=\"spinner-item loading-text\" *ngIf=\"loadingText\">{{ loadingText }}</div>\r\n    </div>\r\n</div>\r\n\r\n<ng-template #showTemplate>\r\n  <div class=\"spinner-container\" [innerHTML]=\"template\"></div>\r\n</ng-template>\r\n",
                    styles: [".noselect{-moz-user-select:none;-ms-user-select:none;-webkit-touch-callout:none;-webkit-user-select:none;user-select:none}.overlay{background-color:rgba(24,24,24,.5);height:100%;left:0;opacity:0;pointer-events:none;position:fixed;top:0;transition:opacity .5s;width:100%}.overlay.on{opacity:1;pointer-events:auto}.spinner-container{align-items:center;color:#fff;display:flex;flex-direction:column;font-family:Arial,Helvetica Neue,Helvetica,sans-serif;height:100%;justify-content:center}.loading-text{font-size:1.5em;text-align:center;text-shadow:0 0 .5rem #202020}.lds-default{display:inline-block;height:80px;position:relative;width:80px}.lds-default div{-webkit-animation:lds-default 1.2s linear infinite;animation:lds-default 1.2s linear infinite;background:#fff;border-radius:50%;height:6px;position:absolute;width:6px}.lds-default div:first-child{-webkit-animation-delay:0s;animation-delay:0s;left:66px;top:37px}.lds-default div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s;left:62px;top:22px}.lds-default div:nth-child(3){-webkit-animation-delay:-.2s;animation-delay:-.2s;left:52px;top:11px}.lds-default div:nth-child(4){-webkit-animation-delay:-.3s;animation-delay:-.3s;left:37px;top:7px}.lds-default div:nth-child(5){-webkit-animation-delay:-.4s;animation-delay:-.4s;left:22px;top:11px}.lds-default div:nth-child(6){-webkit-animation-delay:-.5s;animation-delay:-.5s;left:11px;top:22px}.lds-default div:nth-child(7){-webkit-animation-delay:-.6s;animation-delay:-.6s;left:7px;top:37px}.lds-default div:nth-child(8){-webkit-animation-delay:-.7s;animation-delay:-.7s;left:11px;top:52px}.lds-default div:nth-child(9){-webkit-animation-delay:-.8s;animation-delay:-.8s;left:22px;top:62px}.lds-default div:nth-child(10){-webkit-animation-delay:-.9s;animation-delay:-.9s;left:37px;top:66px}.lds-default div:nth-child(11){-webkit-animation-delay:-1s;animation-delay:-1s;left:52px;top:62px}.lds-default div:nth-child(12){-webkit-animation-delay:-1.1s;animation-delay:-1.1s;left:62px;top:52px}@-webkit-keyframes lds-default{0%,20%,80%,to{transform:scale(1)}50%{transform:scale(1.5)}}@keyframes lds-default{0%,20%,80%,to{transform:scale(1)}50%{transform:scale(1.5)}}"]
                },] }
    ];
    NgxLoadingSpinnerComponent.ctorParameters = function () { return [
        { type: NgxLoadingSpinnerService }
    ]; };
    NgxLoadingSpinnerComponent.propDecorators = {
        timeout: [{ type: i0.Input }],
        threshold: [{ type: i0.Input }],
        zIndex: [{ type: i0.Input }],
        loadingText: [{ type: i0.Input }],
        template: [{ type: i0.Input }]
    };

    var NgxLoadingSpinnerModule = /** @class */ (function () {
        function NgxLoadingSpinnerModule() {
        }
        NgxLoadingSpinnerModule.forRoot = function () {
            return {
                ngModule: NgxLoadingSpinnerModule,
                providers: [NgxLoadingSpinnerService]
            };
        };
        return NgxLoadingSpinnerModule;
    }());
    NgxLoadingSpinnerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxLoadingSpinnerComponent],
                    imports: [
                        platformBrowser.BrowserModule
                    ],
                    exports: [NgxLoadingSpinnerComponent]
                },] }
    ];

    /*
     * Public API Surface of ngx-loading-spinner
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxLoadingSpinnerComponent = NgxLoadingSpinnerComponent;
    exports.NgxLoadingSpinnerModule = NgxLoadingSpinnerModule;
    exports.NgxLoadingSpinnerService = NgxLoadingSpinnerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=k-adam-ngx-loading-spinner.umd.js.map
